Index: sys/netinet/sctp_syscalls.c
===================================================================
--- sys/netinet/sctp_syscalls.c	(revision 312784)
+++ sys/netinet/sctp_syscalls.c	(working copy)
@@ -152,29 +152,11 @@ sys_sctp_peeloff(td, uap)
 	td->td_retval[0] = fd;
 
 	CURVNET_SET(head->so_vnet);
-	so = sonewconn(head, SS_ISCONNECTED);
+	so = sopeeloff(head);
 	if (so == NULL) {
 		error = ENOMEM;
 		goto noconnection;
 	}
-	/*
-	 * Before changing the flags on the socket, we have to bump the
-	 * reference count.  Otherwise, if the protocol calls sofree(),
-	 * the socket will be released due to a zero refcount.
-	 */
-        SOCK_LOCK(so);
-        soref(so);                      /* file descriptor reference */
-        SOCK_UNLOCK(so);
-
-	ACCEPT_LOCK();
-
-	TAILQ_REMOVE(&head->so_comp, so, so_list);
-	head->so_qlen--;
-	so->so_state |= (head->so_state & SS_NBIO);
-	so->so_state &= ~SS_NOFDREF;
-	so->so_qstate &= ~SQ_COMP;
-	so->so_head = NULL;
-	ACCEPT_UNLOCK();
 	finit(nfp, fflag, DTYPE_SOCKET, so, &socketops);
 	error = sctp_do_peeloff(head, so, (sctp_assoc_t)uap->name);
 	if (error != 0)
Index: sys/netinet/sctp_usrreq.c
===================================================================
--- sys/netinet/sctp_usrreq.c	(revision 312784)
+++ sys/netinet/sctp_usrreq.c	(working copy)
@@ -6985,19 +6985,11 @@ out_now:
 #endif
 
 int
-sctp_listen(struct socket *so, int backlog, struct thread *p)
+sctp_listen(struct socket *so, struct solisten *sol, int backlog,
+    struct thread *p)
 {
-	/*
-	 * Note this module depends on the protocol processing being called
-	 * AFTER any socket level flags and backlog are applied to the
-	 * socket. The traditional way that the socket flags are applied is
-	 * AFTER protocol processing. We have made a change to the
-	 * sys/kern/uipc_socket.c module to reverse this but this MUST be in
-	 * place if the socket API for SCTP is to work properly.
-	 */
-
-	int error = 0;
 	struct sctp_inpcb *inp;
+	int error;
 
 	inp = (struct sctp_inpcb *)so->so_pcb;
 	if (inp == NULL) {
@@ -7096,13 +7088,6 @@ int
 		sctp_log_lock(inp, (struct sctp_tcb *)NULL, SCTP_LOG_LOCK_SOCK);
 	}
 #endif
-	SOCK_LOCK(so);
-	error = solisten_proto_check(so);
-	SOCK_UNLOCK(so);
-	if (error) {
-		SCTP_INP_RUNLOCK(inp);
-		return (error);
-	}
 	if ((sctp_is_feature_on(inp, SCTP_PCB_FLAGS_PORTREUSE)) &&
 	    (inp->sctp_flags & SCTP_PCB_FLAGS_IN_TCPPOOL)) {
 		/*
@@ -7132,19 +7117,17 @@ int
 			return (error);
 		}
 	}
-	SOCK_LOCK(so);
-	/* It appears for 7.0 and on, we must always call this. */
-	solisten_proto(so, backlog);
-	if (inp->sctp_flags & SCTP_PCB_FLAGS_UDPTYPE) {
-		/* remove the ACCEPTCONN flag for one-to-many sockets */
-		so->so_options &= ~SO_ACCEPTCONN;
-	}
-	if (backlog == 0) {
-		/* turning off listen */
-		so->so_options &= ~SO_ACCEPTCONN;
-	}
-	SOCK_UNLOCK(so);
-	return (error);
+
+	/*
+	 * If it is a one-to-many socket, or backlog is 0, we refuse
+	 * transfer to solisten.
+	 */
+	if ((inp->sctp_flags & SCTP_PCB_FLAGS_UDPTYPE) || backlog == 0)
+		return (ENOTSOCK);
+
+	inp->sctp_flags |= SCTP_PCB_FLAGS_ACCEPTING;
+	inp->sctp_solisten = sol;
+	return (0);
 }
 
 static int sctp_defered_wakeup_cnt = 0;
Index: sys/netinet/tcp_input.c
===================================================================
--- sys/netinet/tcp_input.c	(revision 312784)
+++ sys/netinet/tcp_input.c	(working copy)
@@ -601,6 +601,7 @@ tcp_input(struct mbuf **mp, int *offp, int proto)
 	struct inpcb *inp = NULL;
 	struct tcpcb *tp = NULL;
 	struct socket *so = NULL;
+	struct solisten *sol = NULL;
 	u_char *optp = NULL;
 	int off0;
 	int optlen = 0;
@@ -633,6 +634,7 @@ tcp_input(struct mbuf **mp, int *offp, int proto)
 	u_char tcp_saveipgen[IP6_HDR_LEN];
 	struct tcphdr tcp_savetcp;
 	short ostate = 0;
+	bool debug = false;
 #endif
 
 #ifdef INET6
@@ -940,7 +942,7 @@ findpcb:
 	if ((inp->inp_flowtype == M_HASHTYPE_NONE) &&
 	    (M_HASHTYPE_GET(m) != M_HASHTYPE_NONE) &&
 	    ((inp->inp_socket == NULL) ||
-	    (inp->inp_socket->so_options & SO_ACCEPTCONN) == 0)) {
+	    (inp->inp_flags2 & INP_LISTENING) == 0)) {
 		inp->inp_flowid = m->m_pkthdr.flowid;
 		inp->inp_flowtype = M_HASHTYPE_GET(m);
 	}
@@ -1077,10 +1079,21 @@ relocked:
 	if (mac_inpcb_check_deliver(inp, m))
 		goto dropunlock;
 #endif
-	so = inp->inp_socket;
-	KASSERT(so != NULL, ("%s: so == NULL", __func__));
+	if (inp->inp_flags2 & INP_LISTENING) {
+		sol = inp->inp_solisten;
 #ifdef TCPDEBUG
-	if (so->so_options & SO_DEBUG) {
+		debug = sol->sol_options & SO_DEBUG;
+#endif
+	} else {
+		so = inp->inp_socket;
+#ifdef TCPDEBUG
+		debug = so->so_options & SO_DEBUG;
+#endif
+	}
+	KASSERT(so != NULL || sol != NULL,
+	    ("%s: inp %p has not socket", __func__, inp));
+#ifdef TCPDEBUG
+	if (debug) {
 		ostate = tp->t_state;
 #ifdef INET6
 		if (isipv6) {
@@ -1096,9 +1109,10 @@ relocked:
 	 * state) we look into the SYN cache if this is a new connection
 	 * attempt or the completion of a previous one.
 	 */
-	KASSERT(tp->t_state == TCPS_LISTEN || !(so->so_options & SO_ACCEPTCONN),
-	    ("%s: so accepting but tp %p not listening", __func__, tp));
-	if (tp->t_state == TCPS_LISTEN && (so->so_options & SO_ACCEPTCONN)) {
+	KASSERT(tp->t_state == TCPS_LISTEN ||
+	    !(inp->inp_flags2 & INP_LISTENING),
+	    ("%s: pcb listening but tp %p not listening", __func__, tp));
+	if (tp->t_state == TCPS_LISTEN && (inp->inp_flags2 & INP_LISTENING)) {
 		struct in_conninfo inc;
 
 		bzero(&inc, sizeof(inc));
@@ -1115,7 +1129,7 @@ relocked:
 		}
 		inc.inc_fport = th->th_sport;
 		inc.inc_lport = th->th_dport;
-		inc.inc_fibnum = so->so_fibnum;
+		inc.inc_fibnum = sol->sol_fibnum;
 
 		/*
 		 * Check for an existing connection attempt in syncache if
@@ -1135,7 +1149,7 @@ relocked:
 			 * NB: syncache_expand() doesn't unlock
 			 * inp and tcpinfo locks.
 			 */
-			if (!syncache_expand(&inc, &to, th, &so, m)) {
+			if (!syncache_expand(&inc, &to, th, sol, &so, m)) {
 				/*
 				 * No syncache entry or ACK was not
 				 * for our SYN/ACK.  Send a RST.
@@ -1404,7 +1418,7 @@ tfo_socket_result:
 		 * for syncache.
 		 */
 #ifdef TCPDEBUG
-		if (so->so_options & SO_DEBUG)
+		if (debug)
 			tcp_trace(TA_INPUT, ostate, tp,
 			    (void *)tcp_saveipgen, &tcp_savetcp, 0);
 #endif
@@ -1411,10 +1425,10 @@ tfo_socket_result:
 		TCP_PROBE3(debug__input, tp, th, m);
 		tcp_dooptions(&to, optp, optlen, TO_SYN);
 #ifdef TCP_RFC7413
-		if (syncache_add(&inc, &to, th, inp, &so, m, NULL, NULL))
+		if (syncache_add(&inc, &to, th, inp, sol, m, NULL, NULL))
 			goto tfo_socket_result;
 #else
-		syncache_add(&inc, &to, th, inp, &so, m, NULL, NULL);
+		syncache_add(&inc, &to, th, inp, sol, m, NULL, NULL);
 #endif
 		/*
 		 * Entry added to syncache and mbuf consumed.
@@ -1428,6 +1442,7 @@ tfo_socket_result:
 		return (IPPROTO_DONE);
 	} else if (tp->t_state == TCPS_LISTEN) {
 		/*
+		 * QQQ
 		 * When a listen socket is torn down the SO_ACCEPTCONN
 		 * flag is removed first while connections are drained
 		 * from the accept queue in a unlock/lock cycle of the
Index: sys/netinet/tcp_subr.c
===================================================================
--- sys/netinet/tcp_subr.c	(revision 312784)
+++ sys/netinet/tcp_subr.c	(working copy)
@@ -1557,12 +1557,13 @@ tcp_close(struct tcpcb *tp)
 {
 	struct inpcb *inp = tp->t_inpcb;
 	struct socket *so;
+	bool listening = (tp->t_state == TCPS_LISTEN);
 
 	INP_INFO_LOCK_ASSERT(&V_tcbinfo);
 	INP_WLOCK_ASSERT(inp);
 
 #ifdef TCP_OFFLOAD
-	if (tp->t_state == TCPS_LISTEN)
+	if (listening)
 		tcp_offload_listen_stop(tp);
 #endif
 #ifdef TCP_RFC7413
@@ -1580,6 +1581,12 @@ tcp_close(struct tcpcb *tp)
 	TCPSTAT_INC(tcps_closed);
 	if (tp->t_state != TCPS_CLOSED)
 		tcp_state_change(tp, TCPS_CLOSED);
+	if (listening) {
+		tcp_discardcb(tp);
+		in_pcbdetach(inp);
+		in_pcbfree(inp);
+		return (NULL);
+	}
 	KASSERT(inp->inp_socket != NULL, ("tcp_close: inp_socket NULL"));
 	so = inp->inp_socket;
 	soisdisconnected(so);
@@ -1588,7 +1595,6 @@ tcp_close(struct tcpcb *tp)
 		    ("tcp_close: !SS_PROTOREF"));
 		inp->inp_flags &= ~INP_SOCKREF;
 		INP_WUNLOCK(inp);
-		ACCEPT_LOCK();
 		SOCK_LOCK(so);
 		so->so_state &= ~SS_PROTOREF;
 		sofree(so);
@@ -1802,9 +1808,14 @@ tcp_pcblist(SYSCTL_HANDLER_ARGS)
 				if (xt.xt_tp.t_timers)
 					tcp_timer_to_xtimer(&xt.xt_tp, xt.xt_tp.t_timers, &xt.xt_timer);
 			}
-			if (inp->inp_socket != NULL)
-				sotoxsocket(inp->inp_socket, &xt.xt_socket);
-			else {
+			if (inp->inp_socket != NULL) {
+				if (inp->inp_flags2 & INP_LISTENING)
+					soltoxsocket(inp->inp_solisten,
+					    &xt.xt_socket);
+				else
+					sotoxsocket(inp->inp_socket,
+					    &xt.xt_socket);
+			} else {
 				bzero(&xt.xt_socket, sizeof xt.xt_socket);
 				xt.xt_socket.xso_protocol = IPPROTO_TCP;
 			}
@@ -2964,7 +2975,7 @@ sysctl_drop(SYSCTL_HANDLER_ARGS)
 			else
 				INP_WUNLOCK(inp);
 		} else if (!(inp->inp_flags & INP_DROPPED) &&
-			   !(inp->inp_socket->so_options & SO_ACCEPTCONN)) {
+			   !(inp->inp_flags2 & INP_LISTENING)) {
 			tp = intotcpcb(inp);
 			tp = tcp_drop(tp, ECONNABORTED);
 			if (tp != NULL)
Index: sys/netinet/tcp_syncache.c
===================================================================
--- sys/netinet/tcp_syncache.c	(revision 312784)
+++ sys/netinet/tcp_syncache.c	(working copy)
@@ -129,7 +129,7 @@ static void	 syncache_free(struct syncache *);
 static void	 syncache_insert(struct syncache *, struct syncache_head *);
 static int	 syncache_respond(struct syncache *, struct syncache_head *, int,
 		    const struct mbuf *);
-static struct	 socket *syncache_socket(struct syncache *, struct socket *,
+static struct	 socket *syncache_socket(struct syncache *, struct solisten *,
 		    struct mbuf *m);
 static void	 syncache_timeout(struct syncache *sc, struct syncache_head *sch,
 		    int docallout);
@@ -141,12 +141,12 @@ static tcp_seq	 syncookie_generate(struct syncache
 static struct syncache
 		*syncookie_lookup(struct in_conninfo *, struct syncache_head *,
 		    struct syncache *, struct tcphdr *, struct tcpopt *,
-		    struct socket *);
+		    struct solisten *);
 static void	 syncookie_reseed(void *);
 #ifdef INVARIANTS
-static int	 syncookie_cmp(struct in_conninfo *inc, struct syncache_head *sch,
-		    struct syncache *sc, struct tcphdr *th, struct tcpopt *to,
-		    struct socket *lso);
+static int	 syncookie_cmp(struct in_conninfo *, struct syncache_head *,
+		    struct syncache *, struct tcphdr *, struct tcpopt *,
+		    struct solisten *);
 #endif
 
 /*
@@ -635,7 +635,7 @@ done:
  * On success return the newly created socket with its underlying inp locked.
  */
 static struct socket *
-syncache_socket(struct syncache *sc, struct socket *lso, struct mbuf *m)
+syncache_socket(struct syncache *sc, struct solisten *sol, struct mbuf *m)
 {
 	struct tcp_function_block *blk;
 	struct inpcb *inp = NULL;
@@ -652,7 +652,7 @@ static struct socket *
 	 * connection when the SYN arrived.  If we can't create
 	 * the connection, abort it.
 	 */
-	so = sonewconn(lso, 0);
+	so = sonewconn(sol, 0);
 	if (so == NULL) {
 		/*
 		 * Drop the connection; we will either send a RST or
@@ -738,12 +738,12 @@ static struct socket *
 	}
 #ifdef IPSEC
 	/* Copy old policy into new socket's. */
-	if (ipsec_copy_policy(sotoinpcb(lso)->inp_sp, inp->inp_sp))
+	if (ipsec_copy_policy(soltoinpcb(sol)->inp_sp, inp->inp_sp))
 		printf("syncache_socket: could not copy policy\n");
 #endif
 #ifdef INET6
 	if (sc->sc_inc.inc_flags & INC_ISIPV6) {
-		struct inpcb *oinp = sotoinpcb(lso);
+		struct inpcb *oinp = soltoinpcb(sol);
 		struct in6_addr laddr6;
 		struct sockaddr_in6 sin6;
 		/*
@@ -829,7 +829,7 @@ static struct socket *
 	tp->irs = sc->sc_irs;
 	tcp_rcvseqinit(tp);
 	tcp_sendseqinit(tp);
-	blk = sototcpcb(lso)->t_fb;
+	blk = soltotcpcb(sol)->t_fb;
 	if (blk != tp->t_fb) {
 		/*
 		 * Our parents t_fb was not the default,
@@ -857,7 +857,7 @@ static struct socket *
 	tp->rcv_adv += tp->rcv_wnd;
 	tp->last_ack_sent = tp->rcv_nxt;
 
-	tp->t_flags = sototcpcb(lso)->t_flags & (TF_NOPUSH|TF_NODELAY);
+	tp->t_flags = soltotcpcb(sol)->t_flags & (TF_NOPUSH|TF_NODELAY);
 	if (sc->sc_flags & SCF_NOOPT)
 		tp->t_flags |= TF_NOOPT;
 	else {
@@ -912,10 +912,10 @@ static struct socket *
 	/*
 	 * Copy and activate timers.
 	 */
-	tp->t_keepinit = sototcpcb(lso)->t_keepinit;
-	tp->t_keepidle = sototcpcb(lso)->t_keepidle;
-	tp->t_keepintvl = sototcpcb(lso)->t_keepintvl;
-	tp->t_keepcnt = sototcpcb(lso)->t_keepcnt;
+	tp->t_keepinit = soltotcpcb(sol)->t_keepinit;
+	tp->t_keepidle = soltotcpcb(sol)->t_keepidle;
+	tp->t_keepintvl = soltotcpcb(sol)->t_keepintvl;
+	tp->t_keepcnt = soltotcpcb(sol)->t_keepcnt;
 	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
 
 	TCPSTAT_INC(tcps_accepts);
@@ -941,7 +941,7 @@ abort2:
  */
 int
 syncache_expand(struct in_conninfo *inc, struct tcpopt *to, struct tcphdr *th,
-    struct socket **lsop, struct mbuf *m)
+    struct solisten *sol, struct socket **so, struct mbuf *m)
 {
 	struct syncache *sc;
 	struct syncache_head *sch;
@@ -965,7 +965,7 @@ syncache_expand(struct in_conninfo *inc, struct tc
 	 * values with the reconstructed values from the cookie.
 	 */
 	if (sc != NULL)
-		syncookie_cmp(inc, sch, sc, th, to, *lsop);
+		syncookie_cmp(inc, sch, sc, th, to, sol);
 #endif
 
 	if (sc == NULL) {
@@ -987,7 +987,7 @@ syncache_expand(struct in_conninfo *inc, struct tc
 			goto failed;
 		}
 		bzero(&scs, sizeof(scs));
-		sc = syncookie_lookup(inc, sch, &scs, th, to, *lsop);
+		sc = syncookie_lookup(inc, sch, &scs, th, to, sol);
 		SCH_UNLOCK(sch);
 		if (sc == NULL) {
 			if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
@@ -1087,9 +1087,9 @@ syncache_expand(struct in_conninfo *inc, struct tc
 		goto failed;
 	}
 
-	*lsop = syncache_socket(sc, *lsop, m);
+	*so = syncache_socket(sc, sol, m);
 
-	if (*lsop == NULL)
+	if (*so == NULL)
 		TCPSTAT_INC(tcps_sc_aborted);
 	else
 		TCPSTAT_INC(tcps_sc_completed);
@@ -1103,7 +1103,7 @@ failed:
 		syncache_free(sc);
 	if (s != NULL)
 		free(s, M_TCPLOG);
-	*lsop = NULL;
+	*so = NULL;
 	return (0);
 }
 
@@ -1161,7 +1161,7 @@ syncache_tfo_expand(struct syncache *sc, struct so
  */
 int
 syncache_add(struct in_conninfo *inc, struct tcpopt *to, struct tcphdr *th,
-    struct inpcb *inp, struct socket **lsop, struct mbuf *m, void *tod,
+    struct inpcb *inp, struct solisten *sol, struct mbuf *m, void *tod,
     void *todctx)
 {
 	struct tcpcb *tp;
@@ -1193,12 +1193,11 @@ syncache_add(struct in_conninfo *inc, struct tcpop
 	    ("%s: unexpected tcp flags", __func__));
 
 	/*
-	 * Combine all so/tp operations very early to drop the INP lock as
-	 * soon as possible.
+	 * Combine all solisten/tp operations very early to drop the INP
+	 * lock as soon as possible.
 	 */
-	so = *lsop;
-	tp = sototcpcb(so);
-	cred = crhold(so->so_cred);
+	tp = soltotcpcb(sol);
+	cred = crhold(sol->sol_cred);
 
 #ifdef INET6
 	if ((inc->inc_flags & INC_ISIPV6) &&
@@ -1207,7 +1206,7 @@ syncache_add(struct in_conninfo *inc, struct tcpop
 #endif
 	ip_ttl = inp->inp_ip_ttl;
 	ip_tos = inp->inp_ip_tos;
-	win = sbspace(&so->so_rcv);
+	win = sol->sol_sbrcv_hiwat;
 	ltflags = (tp->t_flags & (TF_NOOPT | TF_SIGNATURE));
 
 #ifdef TCP_RFC7413
@@ -1220,7 +1219,7 @@ syncache_add(struct in_conninfo *inc, struct tcpop
 		 * listen queue with bogus TFO connections.
 		 */
 		if (atomic_fetchadd_int(tp->t_tfo_pending, 1) <=
-		    (so->so_qlimit / 2)) {
+		    (sol->sol_qlimit / 2)) {
 			int result;
 
 			result = tcp_fastopen_check_cookie(inc,
@@ -1498,10 +1497,7 @@ skip_alloc:
 	}
 
 done:
-	if (m) {
-		*lsop = NULL;
-		m_freem(m);
-	}
+	m_freem(m);
 #ifdef TCP_RFC7413
 	/*
 	 * If tfo_pending is not NULL here, then a TFO SYN that did not
@@ -1981,7 +1977,7 @@ syncookie_generate(struct syncache_head *sch, stru
 static struct syncache *
 syncookie_lookup(struct in_conninfo *inc, struct syncache_head *sch, 
     struct syncache *sc, struct tcphdr *th, struct tcpopt *to,
-    struct socket *lso)
+    struct solisten *sol)
 {
 	uint32_t hash;
 	uint8_t *secbits;
@@ -2024,13 +2020,13 @@ syncookie_lookup(struct in_conninfo *inc, struct s
 	switch (inc->inc_flags & INC_ISIPV6) {
 #ifdef INET
 	case 0:
-		sc->sc_ip_ttl = sotoinpcb(lso)->inp_ip_ttl;
-		sc->sc_ip_tos = sotoinpcb(lso)->inp_ip_tos;
+		sc->sc_ip_ttl = soltoinpcb(sol)->inp_ip_ttl;
+		sc->sc_ip_tos = soltoinpcb(sol)->inp_ip_tos;
 		break;
 #endif
 #ifdef INET6
 	case INC_ISIPV6:
-		if (sotoinpcb(lso)->inp_flags & IN6P_AUTOFLOWLABEL)
+		if (soltoinpcb(sol)->inp_flags & IN6P_AUTOFLOWLABEL)
 			sc->sc_flowlabel = sc->sc_iss & IPV6_FLOWLABEL_MASK;
 		break;
 #endif
@@ -2049,7 +2045,7 @@ syncookie_lookup(struct in_conninfo *inc, struct s
 		sc->sc_flags |= SCF_WINSCALE;
 	}
 
-	wnd = sbspace(&lso->so_rcv);
+	wnd = sol->sol_sbrcv_hiwat;
 	wnd = imax(wnd, 0);
 	wnd = imin(wnd, TCP_MAXWIN);
 	sc->sc_wnd = wnd;
@@ -2077,13 +2073,13 @@ syncookie_lookup(struct in_conninfo *inc, struct s
 static int
 syncookie_cmp(struct in_conninfo *inc, struct syncache_head *sch,
     struct syncache *sc, struct tcphdr *th, struct tcpopt *to,
-    struct socket *lso)
+    struct solisten *sol)
 {
 	struct syncache scs, *scx;
 	char *s;
 
 	bzero(&scs, sizeof(scs));
-	scx = syncookie_lookup(inc, sch, &scs, th, to, lso);
+	scx = syncookie_lookup(inc, sch, &scs, th, to, sol);
 
 	if ((s = tcp_log_addrs(inc, th, NULL, NULL)) == NULL)
 		return (0);
Index: sys/netinet/tcp_syncache.h
===================================================================
--- sys/netinet/tcp_syncache.h	(revision 312784)
+++ sys/netinet/tcp_syncache.h	(working copy)
@@ -40,9 +40,10 @@ void	syncache_destroy(void);
 #endif
 void	 syncache_unreach(struct in_conninfo *, struct tcphdr *);
 int	 syncache_expand(struct in_conninfo *, struct tcpopt *,
-	     struct tcphdr *, struct socket **, struct mbuf *);
+	     struct tcphdr *, struct solisten *, struct socket **,
+	     struct mbuf *);
 int	 syncache_add(struct in_conninfo *, struct tcpopt *,
-	     struct tcphdr *, struct inpcb *, struct socket **, struct mbuf *,
+	     struct tcphdr *, struct inpcb *, struct solisten *, struct mbuf *,
 	     void *, void *);
 void	 syncache_chkrst(struct in_conninfo *, struct tcphdr *);
 void	 syncache_badack(struct in_conninfo *);
Index: sys/netinet/tcp_timewait.c
===================================================================
--- sys/netinet/tcp_timewait.c	(revision 312784)
+++ sys/netinet/tcp_timewait.c	(working copy)
@@ -352,7 +352,6 @@ tcp_twstart(struct tcpcb *tp)
 		    ("tcp_twstart: !SS_PROTOREF"));
 		inp->inp_flags &= ~INP_SOCKREF;
 		INP_WUNLOCK(inp);
-		ACCEPT_LOCK();
 		SOCK_LOCK(so);
 		so->so_state &= ~SS_PROTOREF;
 		sofree(so);
@@ -491,7 +490,6 @@ tcp_twclose(struct tcptw *tw, int reuse)
 		if (inp->inp_flags & INP_SOCKREF) {
 			inp->inp_flags &= ~INP_SOCKREF;
 			INP_WUNLOCK(inp);
-			ACCEPT_LOCK();
 			SOCK_LOCK(so);
 			KASSERT(so->so_state & SS_PROTOREF,
 			    ("tcp_twclose: INP_SOCKREF && !SS_PROTOREF"));
Index: sys/netinet/tcp_usrreq.c
===================================================================
--- sys/netinet/tcp_usrreq.c	(revision 312784)
+++ sys/netinet/tcp_usrreq.c	(working copy)
@@ -394,97 +394,129 @@ out:
  * Prepare to accept connections.
  */
 static int
-tcp_usr_listen(struct socket *so, int backlog, struct thread *td)
+tcp_usr_listen(struct socket *so, struct solisten *sol, int backlog,
+    struct thread *td)
 {
-	int error = 0;
 	struct inpcb *inp;
-	struct tcpcb *tp = NULL;
+	struct tcpcb *tp;
 
 	TCPDEBUG0;
+	if (so == NULL)
+		return (0);
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("tcp_usr_listen: inp == NULL"));
 	INP_WLOCK(inp);
 	if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
-		error = EINVAL;
-		goto out;
+		INP_WUNLOCK(inp);
+		return (EINVAL);
 	}
 	tp = intotcpcb(inp);
 	TCPDEBUG1();
 	SOCK_LOCK(so);
-	error = solisten_proto_check(so);
-	INP_HASH_WLOCK(&V_tcbinfo);
-	if (error == 0 && inp->inp_lport == 0)
+	if (inp->inp_lport == 0) {
+		int error;
+
+		INP_HASH_WLOCK(&V_tcbinfo);
 		error = in_pcbbind(inp, (struct sockaddr *)0, td->td_ucred);
-	INP_HASH_WUNLOCK(&V_tcbinfo);
-	if (error == 0) {
-		tcp_state_change(tp, TCPS_LISTEN);
-		solisten_proto(so, backlog);
+		INP_HASH_WUNLOCK(&V_tcbinfo);
+		if (error) {
+			SOCK_UNLOCK(so);
+			INP_WUNLOCK(inp);
+			return (error);
+		}
+	}
+	tcp_state_change(tp, TCPS_LISTEN);
+	inp->inp_flags2 |= INP_LISTENING;
+	inp->inp_solisten = sol;
 #ifdef TCP_OFFLOAD
-		if ((so->so_options & SO_NO_OFFLOAD) == 0)
-			tcp_offload_listen_start(tp);
+	if ((so->so_options & SO_NO_OFFLOAD) == 0)
+		tcp_offload_listen_start(tp);
 #endif
-	}
 	SOCK_UNLOCK(so);
-
 #ifdef TCP_RFC7413
 	if (IS_FASTOPEN(tp->t_flags))
 		tp->t_tfo_pending = tcp_fastopen_alloc_counter();
 #endif
-out:
 	TCPDEBUG2(PRU_LISTEN);
 	TCP_PROBE2(debug__user, tp, PRU_LISTEN);
 	INP_WUNLOCK(inp);
-	return (error);
+	return (0);
 }
+
+static void
+tcp_usr_listenclose(struct solisten *sol)
+{
+	struct inpcb *inp;
+	struct tcpcb *tp;
+
+	inp = soltoinpcb(sol);
+	INP_INFO_RLOCK(&V_tcbinfo);
+	INP_WLOCK(inp);
+	KASSERT(inp->inp_flags2 & INP_LISTENING,
+	    ("%s: inp %p not listening", __func__, inp));
+	KASSERT(!(inp->inp_flags & INP_DROPPED),
+	    ("%s: listening inp %p dropped", __func__, inp));
+	tp = intotcpcb(inp);
+	TCPDEBUG2(PRU_CLOSE);
+	TCP_PROBE2(debug__user, tp, PRU_CLOSE);
+	tcp_disconnect(tp);
+	/* inp gone */
+	INP_INFO_RUNLOCK(&V_tcbinfo);
+}
 #endif /* INET */
 
 #ifdef INET6
 static int
-tcp6_usr_listen(struct socket *so, int backlog, struct thread *td)
+tcp6_usr_listen(struct socket *so, struct solisten *sol, int backlog,
+    struct thread *td)
 {
-	int error = 0;
 	struct inpcb *inp;
-	struct tcpcb *tp = NULL;
+	struct tcpcb *tp;
 
 	TCPDEBUG0;
+	if (so == NULL)
+		return (0);
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("tcp6_usr_listen: inp == NULL"));
 	INP_WLOCK(inp);
 	if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
-		error = EINVAL;
-		goto out;
+		INP_WUNLOCK(inp);
+		return (EINVAL);
 	}
 	tp = intotcpcb(inp);
 	TCPDEBUG1();
 	SOCK_LOCK(so);
-	error = solisten_proto_check(so);
-	INP_HASH_WLOCK(&V_tcbinfo);
-	if (error == 0 && inp->inp_lport == 0) {
+	if (inp->inp_lport == 0) {
+		int error;
+
 		inp->inp_vflag &= ~INP_IPV4;
 		if ((inp->inp_flags & IN6P_IPV6_V6ONLY) == 0)
 			inp->inp_vflag |= INP_IPV4;
+		INP_HASH_WLOCK(&V_tcbinfo);
 		error = in6_pcbbind(inp, (struct sockaddr *)0, td->td_ucred);
+		INP_HASH_WUNLOCK(&V_tcbinfo);
+		if (error) {
+			SOCK_UNLOCK(so);
+			INP_WUNLOCK(inp);
+			return (error);
+		}
 	}
-	INP_HASH_WUNLOCK(&V_tcbinfo);
-	if (error == 0) {
-		tcp_state_change(tp, TCPS_LISTEN);
-		solisten_proto(so, backlog);
+	tcp_state_change(tp, TCPS_LISTEN);
+	inp->inp_flags2 |= INP_LISTENING;
+	inp->inp_solisten = sol;
 #ifdef TCP_OFFLOAD
-		if ((so->so_options & SO_NO_OFFLOAD) == 0)
-			tcp_offload_listen_start(tp);
+	if ((so->so_options & SO_NO_OFFLOAD) == 0)
+		tcp_offload_listen_start(tp);
 #endif
-	}
 	SOCK_UNLOCK(so);
-
 #ifdef TCP_RFC7413
 	if (IS_FASTOPEN(tp->t_flags))
 		tp->t_tfo_pending = tcp_fastopen_alloc_counter();
 #endif
-out:
 	TCPDEBUG2(PRU_LISTEN);
 	TCP_PROBE2(debug__user, tp, PRU_LISTEN);
 	INP_WUNLOCK(inp);
-	return (error);
+	return (0);
 }
 #endif /* INET6 */
 
@@ -1177,6 +1209,7 @@ struct pr_usrreqs tcp_usrreqs = {
 	.pru_detach =		tcp_usr_detach,
 	.pru_disconnect =	tcp_usr_disconnect,
 	.pru_listen =		tcp_usr_listen,
+	.pru_listenclose =	tcp_usr_listenclose,
 	.pru_peeraddr =		in_getpeeraddr,
 	.pru_rcvd =		tcp_usr_rcvd,
 	.pru_rcvoob =		tcp_usr_rcvoob,
@@ -1200,6 +1233,7 @@ struct pr_usrreqs tcp6_usrreqs = {
 	.pru_detach =		tcp_usr_detach,
 	.pru_disconnect =	tcp_usr_disconnect,
 	.pru_listen =		tcp6_usr_listen,
+	.pru_listenclose =	tcp_usr_listenclose,
 	.pru_peeraddr =		in6_mapped_peeraddr,
 	.pru_rcvd =		tcp_usr_rcvd,
 	.pru_rcvoob =		tcp_usr_rcvoob,
@@ -1392,23 +1426,21 @@ tcp_fill_info(struct tcpcb *tp, struct tcp_info *t
 #define INP_WLOCK_RECHECK(inp) INP_WLOCK_RECHECK_CLEANUP((inp), /* noop */)
 
 int
-tcp_ctloutput(struct socket *so, struct sockopt *sopt)
+tcp_ctloutput(void *xpcb, struct sockopt *sopt)
 {
-	int	error;
-	struct	inpcb *inp;
-	struct	tcpcb *tp;
+	struct inpcb *inp = (struct inpcb *)xpcb;
+	struct tcpcb *tp;
 	struct tcp_function_block *blk;
 	struct tcp_function_set fsn;
+	int	error;
 
 	error = 0;
-	inp = sotoinpcb(so);
-	KASSERT(inp != NULL, ("tcp_ctloutput: inp == NULL"));
 	INP_WLOCK(inp);
 	if (sopt->sopt_level != IPPROTO_TCP) {
 #ifdef INET6
 		if (inp->inp_vflag & INP_IPV6PROTO) {
 			INP_WUNLOCK(inp);
-			error = ip6_ctloutput(so, sopt);
+			error = ip6_ctloutput(inp, sopt);
 		}
 #endif /* INET6 */
 #if defined(INET6) && defined(INET)
@@ -1417,7 +1449,7 @@ int
 #ifdef INET
 		{
 			INP_WUNLOCK(inp);
-			error = ip_ctloutput(so, sopt);
+			error = ip_ctloutput(inp, sopt);
 		}
 #endif
 		return (error);
@@ -1510,18 +1542,19 @@ int
 		return (error);
 	}
 	/* Pass in the INP locked, called must unlock it */
-	return (tp->t_fb->tfb_tcp_ctloutput(so, sopt, inp, tp));
+	return (tp->t_fb->tfb_tcp_ctloutput(inp, sopt));
 }
 
 int
-tcp_default_ctloutput(struct socket *so, struct sockopt *sopt, struct inpcb *inp, struct tcpcb *tp)
+tcp_default_ctloutput(struct inpcb *inp, struct sockopt *sopt)
 {
-	int	error, opt, optval;
-	u_int	ui;
-	struct	tcp_info ti;
+	struct tcp_info ti;
 	struct cc_algo *algo;
+	struct tcpcb *tp = intotcpcb(inp);
 	char	*pbuf, buf[TCP_CA_NAME_MAX];
 	size_t	len;
+	int	error, opt, optval;
+	u_int	ui;
 
 	/*
 	 * For TCP_CCALGOOPT forward the control to CC module, for both
@@ -1946,11 +1979,13 @@ tcp_disconnect(struct tcpcb *tp)
 	INP_WLOCK_ASSERT(inp);
 
 	/*
-	 * Neither tcp_close() nor tcp_drop() should return NULL, as the
-	 * socket is still open.
+	 * For a regular socket neither tcp_close() nor tcp_drop() should
+	 * return NULL, as the socket is still open.
 	 */
-	if (tp->t_state < TCPS_ESTABLISHED) {
+	if (tp->t_state == TCPS_LISTEN)
 		tp = tcp_close(tp);
+	else if (tp->t_state < TCPS_ESTABLISHED) {
+		tp = tcp_close(tp);
 		KASSERT(tp != NULL,
 		    ("tcp_disconnect: tcp_close() returned NULL"));
 	} else if ((so->so_options & SO_LINGER) && so->so_linger == 0) {
Index: sys/netinet/tcp_var.h
===================================================================
--- sys/netinet/tcp_var.h	(revision 312784)
+++ sys/netinet/tcp_var.h	(working copy)
@@ -136,8 +136,7 @@ struct tcp_function_block {
 			    struct socket *, struct tcpcb *,
 			    int, int, uint8_t,
 			    int);
-	int     (*tfb_tcp_ctloutput)(struct socket *so, struct sockopt *sopt,
-			    struct inpcb *inp, struct tcpcb *tp);
+	int     (*tfb_tcp_ctloutput)(struct inpcb *inp, struct sockopt *sopt);
 	/* Optional memory allocation/free routine */
 	void	(*tfb_tcp_fb_init)(struct tcpcb *);
 	void	(*tfb_tcp_fb_fini)(struct tcpcb *, int);
@@ -466,6 +465,7 @@ struct tcptw {
 #define	intotcpcb(ip)	((struct tcpcb *)(ip)->inp_ppcb)
 #define	intotw(ip)	((struct tcptw *)(ip)->inp_ppcb)
 #define	sototcpcb(so)	(intotcpcb(sotoinpcb(so)))
+#define	soltotcpcb(sol)	(intotcpcb(soltoinpcb(sol)))
 
 /*
  * The smoothed round-trip time and estimated variance
@@ -771,7 +771,7 @@ void	 tcp_discardcb(struct tcpcb *);
 void	 tcp_twstart(struct tcpcb *);
 void	 tcp_twclose(struct tcptw *, int);
 void	 tcp_ctlinput(int, struct sockaddr *, void *);
-int	 tcp_ctloutput(struct socket *, struct sockopt *);
+int	 tcp_ctloutput(void *, struct sockopt *);
 struct tcpcb *
 	 tcp_drop(struct tcpcb *, int);
 void	 tcp_drain(void);
@@ -810,7 +810,7 @@ int register_tcp_functions(struct tcp_function_blo
 int deregister_tcp_functions(struct tcp_function_block *blk);
 struct tcp_function_block *find_and_ref_tcp_functions(struct tcp_function_set *fs);
 struct tcp_function_block *find_and_ref_tcp_fb(struct tcp_function_block *blk);
-int tcp_default_ctloutput(struct socket *so, struct sockopt *sopt, struct inpcb *inp, struct tcpcb *tp);
+int tcp_default_ctloutput(struct inpcb *inp, struct sockopt *sopt);
 
 uint32_t tcp_maxmtu(struct in_conninfo *, struct tcp_ifcap *);
 uint32_t tcp_maxmtu6(struct in_conninfo *, struct tcp_ifcap *);
Index: sys/netinet/udp_usrreq.c
===================================================================
--- sys/netinet/udp_usrreq.c	(revision 312784)
+++ sys/netinet/udp_usrreq.c	(working copy)
@@ -988,16 +988,15 @@ SYSCTL_PROC(_net_inet_udp, OID_AUTO, getcred,
 #endif /* INET */
 
 int
-udp_ctloutput(struct socket *so, struct sockopt *sopt)
+udp_ctloutput(void *xpcb, struct sockopt *sopt)
 {
-	struct inpcb *inp;
+	struct inpcb *inp = (struct inpcb *)xpcb;
+	struct socket *so = inp->inp_socket;
 	struct udpcb *up;
 	int isudplite, error, optval;
 
 	error = 0;
 	isudplite = (so->so_proto->pr_protocol == IPPROTO_UDPLITE) ? 1 : 0;
-	inp = sotoinpcb(so);
-	KASSERT(inp != NULL, ("%s: inp == NULL", __func__));
 	INP_WLOCK(inp);
 	if (sopt->sopt_level != so->so_proto->pr_protocol) {
 #ifdef INET6
@@ -1012,7 +1011,7 @@ int
 #ifdef INET
 		{
 			INP_WUNLOCK(inp);
-			error = ip_ctloutput(so, sopt);
+			error = ip_ctloutput(inp, sopt);
 		}
 #endif
 		return (error);
@@ -1027,8 +1026,6 @@ int
 					    sizeof optval);
 			if (error)
 				break;
-			inp = sotoinpcb(so);
-			KASSERT(inp != NULL, ("%s: inp == NULL", __func__));
 			INP_WLOCK(inp);
 #ifdef IPSEC_NAT_T
 			up = intoudpcb(inp);
Index: sys/netinet/udp_var.h
===================================================================
--- sys/netinet/udp_var.h	(revision 312784)
+++ sys/netinet/udp_var.h	(working copy)
@@ -168,7 +168,7 @@ void		udp_discardcb(struct udpcb *);
 
 void		udp_ctlinput(int, struct sockaddr *, void *);
 void		udplite_ctlinput(int, struct sockaddr *, void *);
-int		udp_ctloutput(struct socket *, struct sockopt *);
+int		udp_ctloutput(void *, struct sockopt *);
 void		udp_init(void);
 void		udplite_init(void);
 int		udp_input(struct mbuf **, int *, int);
Index: sys/netinet6/ip6_output.c
===================================================================
--- sys/netinet6/ip6_output.c	(revision 312784)
+++ sys/netinet6/ip6_output.c	(working copy)
@@ -1410,11 +1410,12 @@ ip6_calcmtu(struct ifnet *ifp, const struct in6_ad
  * IP6 socket option processing.
  */
 int
-ip6_ctloutput(struct socket *so, struct sockopt *sopt)
+ip6_ctloutput(void *xpcb, struct sockopt *sopt)
 {
+	struct inpcb *in6p = (struct inpcb *)xpcb;
+	struct socket *so = in6p->inp_socket;
 	int optdatalen, uproto;
 	void *optdata;
-	struct inpcb *in6p = sotoinpcb(so);
 	int error, optval;
 	int level, op, optname;
 	int optlen;
Index: sys/netinet6/ip6_var.h
===================================================================
--- sys/netinet6/ip6_var.h	(revision 312784)
+++ sys/netinet6/ip6_var.h	(working copy)
@@ -385,7 +385,7 @@ int	ip6_output(struct mbuf *, struct ip6_pktopts *
 			int,
 			struct ip6_moptions *, struct ifnet **,
 			struct inpcb *);
-int	ip6_ctloutput(struct socket *, struct sockopt *);
+int	ip6_ctloutput(void *, struct sockopt *);
 int	ip6_raw_ctloutput(struct socket *, struct sockopt *);
 void	ip6_initpktopts(struct ip6_pktopts *);
 int	ip6_setpktopts(struct mbuf *, struct ip6_pktopts *,
@@ -407,7 +407,7 @@ void	frag6_drain(void);
 void	rip6_init(void);
 int	rip6_input(struct mbuf **, int *, int);
 void	rip6_ctlinput(int, struct sockaddr *, void *);
-int	rip6_ctloutput(struct socket *, struct sockopt *);
+int	rip6_ctloutput(void *, struct sockopt *);
 int	rip6_output(struct mbuf *, struct socket *, ...);
 int	rip6_usrreq(struct socket *,
 	    int, struct mbuf *, struct mbuf *, struct mbuf *, struct thread *);
